//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "JvComponentBase"
#pragma link "JvHidControllerClass"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::HIDCtlDeviceChange(TObject *Sender)
{
  //Tato funkce se zavola pri kazde zmene HID zarizeni
  //Program musi pocitat s tim, ze se zarizeni muze
  //kdykoli odpojit
  Memo1->Lines->Add("udalost: DeviceChange");

  //odpojime se
  if (ActiveDevice!=NULL) HIDCtl->CheckIn(ActiveDevice);
  //Znovu nacist zarizeni
  HIDCtl->Enumerate();
  //Naslo se ?
  if (ActiveDevice != NULL) {
	//naslo se -> pripojime obsluhu udalosti
	ActiveDevice->OnData=HIDCtl->OnDeviceData;
	Memo1->Lines->Add("  aktivovana funkce OnDeviceData");
  } else {
	//nenaslo
	Memo1->Lines->Add("  zarizeni nenalezeno");
  }
}
//---------------------------------------------------------------------------

bool __fastcall TForm1::HIDCtlEnumerate(TJvHidDevice *HidDev,
      const int Idx)
{
  //Tato funkce se opakovane vola pro kazde zarizeni HID.
  //Podle VID a PID najdeme to nase
  // a aktivujeme je (funkce checkout)
  AnsiString S;

	if ((HidDev->Attributes.VendorID == 0x16c0) && (HidDev->Attributes.ProductID == 0x05DF))
	{
	  //tohle je nase zarizeni - vypis hodnot
	  S.sprintf("(Ver=%01X.%01X.%01X.%01X, SN=%ls)",
		  ((HidDev->Attributes.VersionNumber)&0xf000) >> 12,
		  ((HidDev->Attributes.VersionNumber)&0x0f00) >> 8,
		  ((HidDev->Attributes.VersionNumber)&0x00f0) >> 4,
		  ((HidDev->Attributes.VersionNumber)&0x000f),
		  HidDev->SerialNumber );
	  Memo1->Lines->Add("  nalezeno: " + HidDev->ProductName +" "+ S);

	  //checkout
	  HIDCtl->CheckOutByIndex(ActiveDevice, Idx);
	}
  return(true);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnDeviceData(TJvHidDevice *HidDev,
      BYTE ReportID, const Pointer Data, WORD Size)
{
  //tato funkce prijima data
  //cekame ReportID = 0
  //Size = 3 (byte)
  unsigned char rep[3];

  rep[0]=((unsigned char *) Data)[0];
  rep[1]=((unsigned char *) Data)[1];
  rep[2]=((unsigned char *) Data)[2];

  Edit2->Text = IntToStr(rep[0]);
  Edit3->Text = IntToStr(rep[1]);
  Edit4->Text = IntToStr(rep[2]);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  if (ActiveDevice!=NULL) HIDCtl->CheckIn(ActiveDevice);        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  ActiveDevice=NULL;
  Memo1->Text = "";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  unsigned char buff[4];
  unsigned int Written;

  //tato funkce posle report do zarizeni
  if (ActiveDevice==NULL) {
	//nejsme pripojeni
	Memo1->Lines->Add("Zarizeni neni pripojeno");
	return;
  }
  //jsme pripojeni
  buff[0] = 0;         // ReportID = 0
  buff[1] = StrToInt(Edit1->Text);
  buff[2] = StrToInt(Edit8->Text);
  buff[3] = StrToInt(Edit9->Text);
  ActiveDevice->WriteFile(buff, 4 , Written);
  Memo1->Lines->Add("odeslano: repID = 0, data = "+Edit1->Text);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  unsigned char buff[4] = {0, 0, 0, 0};
  unsigned int Read;

  if (ActiveDevice==NULL) {
	//nejsme pripojeni
	Memo1->Lines->Add("Zarizeni neni pripojeno");
	return;
  }

  ActiveDevice->ReadFile(buff, 4, Read);

  Edit5->Text = IntToStr(buff[1]);
  Edit6->Text = IntToStr(buff[2]);
  Edit7->Text = IntToStr(buff[3]);
}
//---------------------------------------------------------------------------

